﻿#include <iostream>
#include "S.h"



void printMenu() {

	std::cout << std::endl;
	std::cout << "---------------------------- MENU ----------------------------" << std::endl << std::endl;
	std::cout << "1. Create a new file \"Journal.bin\" and write data into it." << std::endl;
	std::cout << "2. Add data to \"Journal.bin\"." << std::endl;
	std::cout << "3. Output products into Result.txt\"." << std::endl;
	std::cout << "4. Search by storage id." << std::endl;
	std::cout << "5. Search by product code." << std::endl;
	std::cout << "6. Search by arrival date." << std::endl;
	std::cout << "7. Search for expired products." << std::endl;
	std::cout << "8. Search for not-expired products." << std::endl;
	std::cout << "9. Delete a product." << std::endl;
	std::cout << "10. Update a product." << std::endl;
	std::cout << "0. Exit." << std::endl << std::endl;
}

int main() {

	Storage newJournal("Journal.bin", "Result.txt");

	int option = 1;
	while (option != 0) {
		printMenu();

		std::cout << "Enter a number: ";
		std::cin >> option;

		std::string tmp;
		int ind;
		Date curr_date;

		switch (option) {
		case 1:
			try {
				newJournal.create_and_write();
			}
			catch (std::runtime_error err) {
				std::cout << err.what() << std::endl;
			}
			break;

		case 2:
			try {
				newJournal.add_product();
			}
			catch (std::runtime_error err) {
				std::cout << err.what() << std::endl;
			}
			break;

		case 3:
			try {
				newJournal.load_out_txt();
			}
			catch (std::runtime_error err) {
				std::cout << err.what() << std::endl;
			}
			break;

		case 4:
			std::cout << std::endl;
			std::cout << "Input the storage id: ";
			std::cin >> ind;
			newJournal.search_storage_id(ind);
			break;

		case 5:
			std::cout << std::endl << "Input the product code: ";
			int ind;
			std::cin >> ind;
			newJournal.search_product_code(ind);
			break;

		case 6:
			std::cout << std::endl << "Input the arrival date: ";
			std::cin >> curr_date;
			newJournal.search_arrival_date(curr_date);
			break;

		case 7:
			std::cout << std::endl << "Input the current date:  ";
			std::cin >> curr_date;
			newJournal.search_overdue_products(curr_date);
			break;

		case 8:
			std::cout << std::endl << "Input the current date:  ";
			std::cin >> curr_date;
			newJournal.search_not_overdue_products(curr_date);
			break;

		case 9:
			std::cout << std::endl << "Input index of product you want to delete: ";
			std::cin >> ind;
			try {
				newJournal.delete_product(ind);
			}
			catch (std::runtime_error err) {
				std::cout << err.what() << std::endl;
			}
			break;

		case 10:
			std::cout << std::endl << "Input index of the record you want to update: ";
			std::cin >> ind;
			try {
				newJournal.change_product(ind);
			}
			catch (std::runtime_error err) {
				std::cout << err.what() << std::endl;
			}
			break;

		case 0:
			std::cout << std::endl << std::endl << "Goodbye!" << std::endl << std::endl;
			break;

		default:
			std::cout << std::endl << std::endl << "I don't know such a command... Try again please." << std::endl << std::endl;
		}
	}

	return 0;
}

